<template>
  <Filter @update="search"></Filter>
  <!-- 汇总损益报表 -->
  <mtp-table-scroll>
    <template #default="{ scroll }">
      <a-table :columns="columns" class="srcollYTable" :scroll="scroll" :pagination="false" :rowClassName="rowClassName"
        :expandedRowKeys="expandedRowKeys" :customRow="Rowclick" :rowKey="(record,index)=>index"
        :data-source="tableList"></a-table>
    </template>
  </mtp-table-scroll>
  <!-- 明细，日报表不显示“损益明细“标签页 -->
  <mtp-table-detail :columns="columnsDetail" :data-source="detailTableList" :tabs="tabList" v-model:visible="visible"
    @change="changeTab" v-show="cycletype > 0">
    <!-- 期现比例 -->
    <template #futurespotratio="{ record }">
      <span>{{ (record.futurespotratio * 100) + '%' }}</span>
    </template>
  </mtp-table-detail>
</template>

<script lang="ts">
import MtpTableScroll from '@/common/components/tableScroll/index.vue';
import { EnumRouterName } from '@/common/constants/enumRouterName';
import { defineComponent, queryTableList } from '@/common/export/table';
import { queryResultLoadingAndInfo } from '@/common/methods/request/resultInfo';
import { getTableButton } from '@/common/setup/table/button';
import { ComposeTableDetailParam, handleComposeTable_detail } from '@/common/setup/table/compose';
import { qryAreaSumPL } from '@/services/go/ermcp/report';
import { Ermcp3ArealSumPL, QryAreaSumPLReq } from '@/services/go/ermcp/report/interface';
import { TypeAndTime } from '@/views/report/interface';
import { handleInitTypeAndTime } from '@/views/report/setup';
import { ref, watch } from 'vue';
import Filter from '../../components/filterTable/index.vue';
import MtpTableDetail from '@/common/components/tableDetail/index.vue';

export default defineComponent({
  name: 'sum_pl_report',
  components: {
    MtpTableScroll,
    Filter,
    MtpTableDetail,
  },
  setup() {
    let cycletime = '';
    // 周期类型
    const cycletype = ref(0);
    // 表格列表数据
    const { loading, tableList, queryTable } = queryTableList<Ermcp3ArealSumPL>(true, 2);
    // 控制明细显示/隐藏
    const visible = ref(true);
    // 获取列表数据
    const queryTableAction = () => {
      const { getInitTime, getInitType } = handleInitTypeAndTime();
      cycletime = getInitTime();
      const param: QryAreaSumPLReq = {
        cycletype: getInitType(),
        cycletime,
        querytype: 1,
      };
      // 获取列表数据
      queryTable(qryAreaSumPL, param).then((res) => {
        if (res.length) {
          selectedRow.value = res[0];
        } else {
          changeTab(tabIndex.value)
        }
      });
    };
    const param: ComposeTableDetailParam = {
      queryFn: queryTableAction, // 查询表格数据
      tableName: 'table_pcweb_aggregate_profit_and_loss', // 表头key
      menuType: EnumRouterName.sum_pl_report_sum_pl, // 当前tab页对应的code
    };
    const {
      columns,
      updateColumn, //  表头数据
      columnsDetail,
      registerColumnDetail,
      detailTableList, // 明细表头数据
      expandedRowKeys,
      selectedRow,
      rowClassName,
      Rowclick, // 表格事件
    } = handleComposeTable_detail<Ermcp3ArealSumPL>(param);
    const chaceSearchValue = ref<TypeAndTime>();

    // 底部明细标签
    const tabList = getTableButton();
    // 当前选中的标签
    const tabIndex = ref(0);

    // 切换明细
    function changeTab(index: number) {
      const { code, lable } = tabList[index];
      tabIndex.value = index;
      detailTableList.value = [];
      visible.value = true;

      if (code === 'sum_pl_report_profit_and_loss_details') {
        // 损益明细
        // 注册表头
        registerColumnDetail('table_pcweb_inventory_summary_profit_and_loss_details');
      } else {
        console.error(`${lable}没有配置对应的code: ${code},`);
        return;
      }

      if (selectedRow.value) {
        const data = selectedRow.value as Ermcp3ArealSumPL;
        const { cycletype, currencyid } = data;
        const param: QryAreaSumPLReq = {
          querytype: 2,
          cycletype,
          cycletime,
          currencyid,
          userid: chaceSearchValue.value?.userid,
        };
        // 查询明细数据
        queryResultLoadingAndInfo(qryAreaSumPL, loading, param).then((res) => {
          detailTableList.value = res;
        });
      }
    }

    function search(value: TypeAndTime) {
      detailTableList.value = [];
      cycletype.value = value.cycletype;
      chaceSearchValue.value = value;
      cycletime = value.cycletime;
      const obj = Object.assign(value, { querytype: 1 });
      queryTable(qryAreaSumPL, obj).then((res) => {
        if (res.length) {
          selectedRow.value = res[0];
        }
      });
    }

    watch(selectedRow, () => changeTab(tabIndex.value))

    return {
      loading,
      tableList,
      visible,
      updateColumn,
      search,
      columns,
      columnsDetail,
      detailTableList,
      expandedRowKeys,
      selectedRow,
      rowClassName,
      Rowclick,
      tabList,
      changeTab,
      cycletype,
    };
  },
});
</script>
